
local moduleName = "Maintank"



----------------------------
--      Localization      --
----------------------------

local L = AceLibrary("AceLocale-2.2"):new("BunchOfBars"..moduleName)

L:RegisterTranslations("enUS", function() return {
	[moduleName] = "Maintank",

	["Scale"] = true,
	["Maintank frame scale."] = true
} end)



----------------------------------
--      Local Declaration      --
----------------------------------



----------------------------------
--      Module Declaration      --
----------------------------------

local plugin = BunchOfBars:NewModule(moduleName, "AceEvent-2.0")

plugin.revision = tonumber(("$Revision: 39513 $"):match("%d+"))

plugin.options = {
	name = L[moduleName],
	args = {
		frequency = {
			type = "range",
			name = L["Scale"],
			desc = L["Maintank frame scale."],
			min = 1,
            max = 2.0,
            step = 0.1,
            get = "GetSetScale",
            set = "GetSetScale",
		}
	}
}

plugin.defaultDB = {
	scale = 1.2
}



----------------------------------
--      Module Functions        --
----------------------------------

function plugin:OnEnable()
	self:RegisterEvent("oRA_MainTankUpdate", "UpdateAll")

	if _G.CT_RAOptions_UpdateMTs then
		hooksecurefunc("CT_RAOptions_UpdateMTs", function() self:UpdateAll() end)
	end
end


function plugin:OnUpdate(frame)
	local name, tanks = UnitName(frame.unit), nil

	frame:SetScale(1.0)

	if oRA then
		tanks = oRA.maintanktable
	elseif CT_RA_MainTanks then
		tanks = CT_RA_MainTanks
	end

	if not tanks then return end

	for _,v in pairs(tanks) do -- the key is the tank number
		if v == name then
			frame:SetScale(self.db.profile.scale)
			break
		end
	end
end


function plugin:GetSetScale(value)
	if type(value) == "nil" then return self.db.profile.scale end

	-- this check is to assure we don't reschedule the event to often
	if self.db.profile.scale ~= value then
		self.db.profile.scale = value

		self:UpdateAll()
	end
end
